/* Primitive Types */

typedef double 浮点数;

typedef bool 布尔量;

typedef int 整数;

/* Head Files */


/* Class Forward */

class 数学实体_Ultra;

class 数学实体;

class 判定机_Ultra;

class 判定机;

class 矩形_Ultra;

class 矩形;

class 形状判定机_Ultra;

class 形状判定机;


/* Class */

class 数学实体_Ultra {

};

class 数学实体 : public 数学实体_Ultra {

public:

    using UltraType = 数学实体_Ultra;

public:

};

class 判定机_Ultra {

};

class 判定机 : public 判定机_Ultra {

public:

    using UltraType = 判定机_Ultra;

public:

};

class 矩形_Ultra {

  virtual 浮点数 长() const = 0;

  virtual 浮点数 宽() const = 0;

  virtual 浮点数 面积() const = 0;

};

class 矩形 : public 数学实体_Ultra, public 矩形_Ultra {

public:

    using UltraType = 矩形_Ultra;

public:

    浮点数 长_;

    浮点数 宽_;

    virtual 浮点数 长() const override;

    virtual 浮点数 宽() const override;

    virtual 浮点数 面积() const override;

};

class 形状判定机_Ultra {

  virtual 布尔量 判定_正方形(矩形 a) const = 0;

};

class 形状判定机 : public 判定机_Ultra, public 形状判定机_Ultra {

public:

    using UltraType = 形状判定机_Ultra;

public:

    virtual 布尔量 判定_正方形(矩形 a) const override;

};

